VirtualBox

source: vbox/trunk/src/VBox/Additions/linux/installer/vboxadd.sh@ 69500

Last change on this file since 69500 was 69500, checked in by vboxsync, 7 years ago

*: scm --update-copyright-year

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
  • Property svn:keywords set to Author Date Id Revision
File size: 16.1 KB
Line 
1#! /bin/sh
2# $Id: vboxadd.sh 69500 2017-10-28 15:14:05Z vboxsync $
3## @file
4# Linux Additions kernel module init script ($Revision: 69500 $)
5#
6
7#
8# Copyright (C) 2006-2017 Oracle Corporation
9#
10# This file is part of VirtualBox Open Source Edition (OSE), as
11# available from http://www.virtualbox.org. This file is free software;
12# you can redistribute it and/or modify it under the terms of the GNU
13# General Public License (GPL) as published by the Free Software
14# Foundation, in version 2 as it comes in the "COPYING" file of the
15# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
16# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
17#
18
19# X-Start-Before is a Debian Addition which we use when converting to
20# a systemd unit. X-Service-Type is our own invention, also for systemd.
21
22# chkconfig: 345 10 90
23# description: VirtualBox Linux Additions kernel modules
24#
25### BEGIN INIT INFO
26# Provides: vboxadd
27# Required-Start:
28# Required-Stop:
29# Default-Start: 2 3 4 5
30# Default-Stop: 0 1 6
31# X-Start-Before: display-manager
32# X-Service-Type: oneshot
33# Description: VirtualBox Linux Additions kernel modules
34### END INIT INFO
35
36## @todo This file duplicates a lot of script with vboxdrv.sh. When making
37# changes please try to reduce differences between the two wherever possible.
38
39# Testing:
40# * Should fail if the configuration file is missing or missing INSTALL_DIR or
41# INSTALL_VER entries.
42# * vboxadd user and vboxsf groups should be created if they do not exist - test
43# by removing them before installing.
44# * Shared folders can be mounted and auto-mounts accessible to vboxsf group,
45# including on recent Fedoras with SELinux.
46# * Setting INSTALL_NO_MODULE_BUILDS inhibits modules and module automatic
47# rebuild script creation; otherwise modules, user, group, rebuild script,
48# udev rule and shared folder mount helper should be created/set up.
49# * Setting INSTALL_NO_MODULE_BUILDS inhibits module load and unload on start
50# and stop.
51# * Uninstalling the Additions and re-installing them does not trigger warnings.
52
53PATH=$PATH:/bin:/sbin:/usr/sbin
54PACKAGE=VBoxGuestAdditions
55MODPROBE=/sbin/modprobe
56OLDMODULES="vboxguest vboxadd vboxsf vboxvfs vboxvideo"
57SERVICE="VirtualBox Guest Additions"
58QUICKSETUP=
59## systemd logs information about service status, otherwise do that ourselves.
60QUIET=
61
62setup_log()
63{
64 test -n "${LOG}" && return 0
65 # Rotate log files
66 LOG="/var/log/vboxadd-setup.log"
67 mv "${LOG}.3" "${LOG}.4" 2>/dev/null
68 mv "${LOG}.2" "${LOG}.3" 2>/dev/null
69 mv "${LOG}.1" "${LOG}.2" 2>/dev/null
70 mv "${LOG}" "${LOG}.1" 2>/dev/null
71}
72
73if $MODPROBE -c 2>/dev/null | grep -q '^allow_unsupported_modules *0'; then
74 MODPROBE="$MODPROBE --allow-unsupported-modules"
75fi
76
77# Check architecture
78cpu=`uname -m`;
79case "$cpu" in
80 i[3456789]86|x86)
81 cpu="x86"
82 ldconfig_arch="(libc6)"
83 lib_candidates="/usr/lib/i386-linux-gnu /usr/lib /lib"
84 ;;
85 x86_64|amd64)
86 cpu="amd64"
87 ldconfig_arch="(libc6,x86-64)"
88 lib_candidates="/usr/lib/x86_64-linux-gnu /usr/lib64 /usr/lib /lib64 /lib"
89 ;;
90esac
91for i in $lib_candidates; do
92 if test -d "$i/VBoxGuestAdditions"; then
93 lib_path=$i
94 break
95 fi
96done
97
98# Preamble for Gentoo
99if [ "`which $0`" = "/sbin/rc" ]; then
100 shift
101fi
102
103begin()
104{
105 test -z "${QUIET}" && echo "${SERVICE}: ${1}"
106}
107
108info()
109{
110 if test -z "${QUIET}"; then
111 echo "${SERVICE}: $1"
112 else
113 echo "$1"
114 fi
115}
116
117fail()
118{
119 log "${1}"
120 echo "$1" >&2
121 echo "The log file $LOG may contain further information." >&2
122 exit 1
123}
124
125log()
126{
127 setup_log
128 echo "${1}" >> "${LOG}"
129}
130
131dev=/dev/vboxguest
132userdev=/dev/vboxuser
133config=/var/lib/VBoxGuestAdditions/config
134owner=vboxadd
135group=1
136
137if test -r $config; then
138 . $config
139else
140 fail "Configuration file $config not found"
141fi
142test -n "$INSTALL_DIR" -a -n "$INSTALL_VER" ||
143 fail "Configuration file $config not complete"
144
145running_vboxguest()
146{
147 lsmod | grep -q "vboxguest[^_-]"
148}
149
150running_vboxadd()
151{
152 lsmod | grep -q "vboxadd[^_-]"
153}
154
155running_vboxsf()
156{
157 lsmod | grep -q "vboxsf[^_-]"
158}
159
160running_vboxvideo()
161{
162 lsmod | grep -q "vboxvideo[^_-]"
163}
164
165do_vboxguest_non_udev()
166{
167 if [ ! -c $dev ]; then
168 maj=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/devices`
169 if [ ! -z "$maj" ]; then
170 min=0
171 else
172 min=`sed -n 's;\([0-9]\+\) vboxguest;\1;p' /proc/misc`
173 if [ ! -z "$min" ]; then
174 maj=10
175 fi
176 fi
177 test -z "$maj" && {
178 rmmod vboxguest 2>/dev/null
179 fail "Cannot locate the VirtualBox device"
180 }
181
182 mknod -m 0664 $dev c $maj $min || {
183 rmmod vboxguest 2>/dev/null
184 fail "Cannot create device $dev with major $maj and minor $min"
185 }
186 fi
187 chown $owner:$group $dev 2>/dev/null || {
188 rm -f $dev 2>/dev/null
189 rm -f $userdev 2>/dev/null
190 rmmod vboxguest 2>/dev/null
191 fail "Cannot change owner $owner:$group for device $dev"
192 }
193
194 if [ ! -c $userdev ]; then
195 maj=10
196 min=`sed -n 's;\([0-9]\+\) vboxuser;\1;p' /proc/misc`
197 if [ ! -z "$min" ]; then
198 mknod -m 0666 $userdev c $maj $min || {
199 rm -f $dev 2>/dev/null
200 rmmod vboxguest 2>/dev/null
201 fail "Cannot create device $userdev with major $maj and minor $min"
202 }
203 chown $owner:$group $userdev 2>/dev/null || {
204 rm -f $dev 2>/dev/null
205 rm -f $userdev 2>/dev/null
206 rmmod vboxguest 2>/dev/null
207 fail "Cannot change owner $owner:$group for device $userdev"
208 }
209 fi
210 fi
211}
212
213start()
214{
215 begin "Starting."
216 # If we got this far assume that the slow set-up has been done.
217 QUICKSETUP=yes
218 if test -z "${INSTALL_NO_MODULE_BUILDS}"; then
219 uname -r | grep -q -E '^2\.6|^3|^4' 2>/dev/null &&
220 ps -A -o comm | grep -q '/*udevd$' 2>/dev/null ||
221 no_udev=1
222 running_vboxguest || {
223 rm -f $dev || {
224 fail "Cannot remove $dev"
225 }
226
227 rm -f $userdev || {
228 fail "Cannot remove $userdev"
229 }
230
231 $MODPROBE vboxguest >/dev/null 2>&1 || {
232 setup
233 $MODPROBE vboxguest >/dev/null 2>&1 ||
234 fail "modprobe vboxguest failed"
235 }
236 case "$no_udev" in 1)
237 sleep .5;;
238 esac
239 }
240 case "$no_udev" in 1)
241 do_vboxguest_non_udev;;
242 esac
243
244 running_vboxsf || {
245 $MODPROBE vboxsf > /dev/null 2>&1 || {
246 if dmesg | grep "VbglR0SfConnect failed" > /dev/null 2>&1; then
247 info "Unable to start shared folders support. Make sure that your VirtualBox build supports this feature."
248 else
249 info "modprobe vboxsf failed"
250 fi
251 }
252 }
253 fi # INSTALL_NO_MODULE_BUILDS
254
255 # Put the X.Org driver in place. This is harmless if it is not needed.
256 "${INSTALL_DIR}/init/vboxadd-x11" setup 2>> "${LOG}"
257 # Install the guest OpenGL drivers. For now we don't support
258 # multi-architecture installations
259 rm -f /etc/ld.so.conf.d/00vboxvideo.conf
260 rm -Rf /var/lib/VBoxGuestAdditions/lib
261 if /usr/bin/VBoxClient --check3d 2>/dev/null; then
262 mkdir -p /var/lib/VBoxGuestAdditions/lib
263 ln -sf "${INSTALL_DIR}/lib/VBoxOGL.so" /var/lib/VBoxGuestAdditions/lib/libGL.so.1
264 # SELinux for the OpenGL libraries, so that gdm can load them during the
265 # acceleration support check. This prevents an "Oh no, something has gone
266 # wrong!" error when starting EL7 guests.
267 if test -e /etc/selinux/config; then
268 if command -v semanage > /dev/null; then
269 semanage fcontext -a -t lib_t "/var/lib/VBoxGuestAdditions/lib/libGL.so.1"
270 fi
271 chcon -h -t lib_t "/var/lib/VBoxGuestAdditions/lib/libGL.so.1"
272 fi
273 echo "/var/lib/VBoxGuestAdditions/lib" > /etc/ld.so.conf.d/00vboxvideo.conf
274 fi
275 ldconfig
276
277 # Mount all shared folders from /etc/fstab. Normally this is done by some
278 # other startup script but this requires the vboxdrv kernel module loaded.
279 # This isn't necessary anymore as the vboxsf module is autoloaded.
280 # mount -a -t vboxsf
281
282 return 0
283}
284
285stop()
286{
287 begin "Stopping."
288 if test -r /etc/ld.so.conf.d/00vboxvideo.conf; then
289 rm /etc/ld.so.conf.d/00vboxvideo.conf
290 ldconfig
291 fi
292 if ! umount -a -t vboxsf 2>/dev/null; then
293 fail "Cannot unmount vboxsf folders"
294 fi
295 test -n "${INSTALL_NO_MODULE_BUILDS}" && return 0
296 modprobe -q -r -a vboxvideo vboxsf vboxguest
297 if egrep -q 'vboxguest|vboxsf|vboxvideo' /proc/modules; then
298 info "You may need to restart your guest system to finish removing the guest drivers."
299 else
300 rm -f $userdev || fail "Cannot unlink $userdev"
301 rm -f $dev || fail "Cannot unlink $dev"
302 fi
303 return 0
304}
305
306restart()
307{
308 stop && start
309 return 0
310}
311
312# Remove any existing VirtualBox guest kernel modules from the disk, but not
313# from the kernel as they may still be in use
314cleanup_modules()
315{
316 log "Removing existing VirtualBox kernel modules."
317 for i in ${OLDMODULES}; do
318 # We no longer support DKMS, remove any leftovers.
319 rm -rf "/var/lib/dkms/${i}"*
320 # And remove old modules.
321 rm -f /lib/modules/*/misc/"${i}"*
322 done
323 # Remove leftover module folders.
324 for i in /lib/modules/*/misc; do
325 test -d "${i}" && rmdir -p "${i}" 2>/dev/null
326 done
327 rm -f /etc/depmod.d/vboxvideo-upstream.conf
328}
329
330# Build and install the VirtualBox guest kernel modules
331setup_modules()
332{
333 # don't stop the old modules here -- they might be in use
334 test -z "${QUICKSETUP}" && cleanup_modules
335 # This does not work for 2.4 series kernels. How sad.
336 test -n "${QUICKSETUP}" && test -f "${MODULE_DIR}/vboxguest.ko" && return 0
337 info "Building the VirtualBox Guest Additions kernel modules."
338
339 # We are allowed to do ">> $LOG" after we have called "log()" once.
340 log "Building the main Guest Additions module."
341 if ! $BUILDINTMP \
342 --save-module-symvers /tmp/vboxguest-Module.symvers \
343 --module-source $MODULE_SRC/vboxguest \
344 --no-print-directory install >> $LOG 2>&1; then
345 # If check_module_dependencies.sh fails it prints a message itself.
346 "${INSTALL_DIR}"/other/check_module_dependencies.sh 2>&1 &&
347 info "Look at $LOG to find out what went wrong"
348 return 0
349 fi
350 log "Building the shared folder support module"
351 if ! $BUILDINTMP \
352 --use-module-symvers /tmp/vboxguest-Module.symvers \
353 --module-source $MODULE_SRC/vboxsf \
354 --no-print-directory install >> $LOG 2>&1; then
355 info "Look at $LOG to find out what went wrong"
356 return 0
357 fi
358 log "Building the graphics driver module"
359 if ! $BUILDINTMP \
360 --use-module-symvers /tmp/vboxguest-Module.symvers \
361 --module-source $MODULE_SRC/vboxvideo \
362 --no-print-directory install >> $LOG 2>&1; then
363 info "Look at $LOG to find out what went wrong"
364 fi
365 [ -d /etc/depmod.d ] || mkdir /etc/depmod.d
366 echo "override vboxguest * misc" > /etc/depmod.d/vboxvideo-upstream.conf
367 echo "override vboxsf * misc" >> /etc/depmod.d/vboxvideo-upstream.conf
368 echo "override vboxvideo * misc" >> /etc/depmod.d/vboxvideo-upstream.conf
369 depmod
370 return 0
371}
372
373create_vbox_user()
374{
375 log "Creating user for the Guest Additions."
376 # This is the LSB version of useradd and should work on recent
377 # distributions
378 useradd -d /var/run/vboxadd -g 1 -r -s /bin/false vboxadd >/dev/null 2>&1
379 # And for the others, we choose a UID ourselves
380 useradd -d /var/run/vboxadd -g 1 -u 501 -o -s /bin/false vboxadd >/dev/null 2>&1
381
382}
383
384create_udev_rule()
385{
386 # Create udev description file
387 if [ -d /etc/udev/rules.d ]; then
388 log "Creating udev rule for the Guest Additions kernel module."
389 udev_call=""
390 udev_app=`which udevadm 2> /dev/null`
391 if [ $? -eq 0 ]; then
392 udev_call="${udev_app} version 2> /dev/null"
393 else
394 udev_app=`which udevinfo 2> /dev/null`
395 if [ $? -eq 0 ]; then
396 udev_call="${udev_app} -V 2> /dev/null"
397 fi
398 fi
399 udev_fix="="
400 if [ "${udev_call}" != "" ]; then
401 udev_out=`${udev_call}`
402 udev_ver=`expr "$udev_out" : '[^0-9]*\([0-9]*\)'`
403 if [ "$udev_ver" = "" -o "$udev_ver" -lt 55 ]; then
404 udev_fix=""
405 fi
406 fi
407 ## @todo 60-vboxadd.rules -> 60-vboxguest.rules ?
408 echo "KERNEL=${udev_fix}\"vboxguest\", NAME=\"vboxguest\", OWNER=\"vboxadd\", MODE=\"0660\"" > /etc/udev/rules.d/60-vboxadd.rules
409 echo "KERNEL=${udev_fix}\"vboxuser\", NAME=\"vboxuser\", OWNER=\"vboxadd\", MODE=\"0666\"" >> /etc/udev/rules.d/60-vboxadd.rules
410 fi
411}
412
413create_module_rebuild_script()
414{
415 # And a post-installation script for rebuilding modules when a new kernel
416 # is installed.
417 mkdir -p /etc/kernel/postinst.d /etc/kernel/prerm.d
418 cat << EOF > /etc/kernel/postinst.d/vboxadd
419#!/bin/sh
420test -d "/lib/modules/\${1}/build" || exit 0
421KERN_VER="\${1}" /sbin/rcvboxadd quicksetup
422exit 0
423EOF
424 cat << EOF > /etc/kernel/prerm.d/vboxadd
425#!/bin/sh
426for i in ${OLDMODULES}; do rm -f /lib/modules/"\${1}"/misc/"\${i}".ko; done
427rmdir -p /lib/modules/"\$1"/misc 2>/dev/null
428exit 0
429EOF
430 chmod 0755 /etc/kernel/postinst.d/vboxadd /etc/kernel/prerm.d/vboxadd
431}
432
433shared_folder_setup()
434{
435 # Add a group "vboxsf" for Shared Folders access
436 # All users which want to access the auto-mounted Shared Folders have to
437 # be added to this group.
438 groupadd -r -f vboxsf >/dev/null 2>&1
439
440 # Put the mount.vboxsf mount helper in the right place.
441 ## @todo It would be nicer if the kernel module just parsed parameters
442 # itself instead of needing a separate binary to do that.
443 ln -sf "${INSTALL_DIR}/other/mount.vboxsf" /sbin
444 # SELinux security context for the mount helper.
445 if test -e /etc/selinux/config; then
446 # This is correct. semanage maps this to the real path, and it aborts
447 # with an error, telling you what you should have typed, if you specify
448 # the real path. The "chcon" is there as a back-up for old guests.
449 command -v semanage > /dev/null &&
450 semanage fcontext -a -t mount_exec_t "${INSTALL_DIR}/other/mount.vboxsf"
451 chcon -t mount_exec_t "${INSTALL_DIR}/other/mount.vboxsf"
452 fi
453}
454
455# setup_script
456setup()
457{
458 export BUILD_TYPE
459 export USERNAME
460
461 MODULE_SRC="$INSTALL_DIR/src/vboxguest-$INSTALL_VER"
462 BUILDINTMP="$MODULE_SRC/build_in_tmp"
463 chcon -t bin_t "$BUILDINTMP" > /dev/null 2>&1
464
465 test -z "${INSTALL_NO_MODULE_BUILDS}" && setup_modules
466 create_vbox_user
467 create_udev_rule
468 test -z "${INSTALL_NO_MODULE_BUILDS}" && create_module_rebuild_script
469 test -n "${QUICKSETUP}" && return 0
470 shared_folder_setup
471 if running_vboxguest || running_vboxadd; then
472 info "Running kernel modules will not be replaced until the system is restarted"
473 fi
474 return 0
475}
476
477# cleanup_script
478cleanup()
479{
480 if test -z "${INSTALL_NO_MODULE_BUILDS}"; then
481 # Delete old versions of VBox modules.
482 cleanup_modules
483 depmod
484
485 # Remove old module sources
486 for i in $OLDMODULES; do
487 rm -rf /usr/src/$i-*
488 done
489 fi
490
491 # Clean-up X11-related bits
492 "${INSTALL_DIR}/init/vboxadd-x11" cleanup 2>> "${LOG}"
493
494 # Remove other files
495 rm /sbin/mount.vboxsf 2>/dev/null
496 if test -z "${INSTALL_NO_MODULE_BUILDS}"; then
497 rm -f /etc/kernel/postinst.d/vboxadd /etc/kernel/prerm.d/vboxadd
498 rmdir -p /etc/kernel/postinst.d /etc/kernel/prerm.d 2>/dev/null
499 fi
500 rm /etc/udev/rules.d/60-vboxadd.rules 2>/dev/null
501}
502
503dmnstatus()
504{
505 if running_vboxguest; then
506 echo "The VirtualBox Additions are currently running."
507 else
508 echo "The VirtualBox Additions are not currently running."
509 fi
510}
511
512case "$2" in quiet)
513 QUIET=yes;;
514esac
515case "$1" in
516start)
517 start
518 ;;
519stop)
520 stop
521 ;;
522restart)
523 restart
524 ;;
525setup)
526 setup
527 start
528 ;;
529quicksetup)
530 QUICKSETUP=yes
531 setup
532 ;;
533cleanup)
534 cleanup
535 ;;
536status)
537 dmnstatus
538 ;;
539*)
540 echo "Usage: $0 {start|stop|restart|status|setup|quicksetup|cleanup} [quiet]"
541 exit 1
542esac
543
544exit
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use